      real XMIN,XMAX,DX,YMIN,YMAX,DY
      real FMAP(64)
      integer ISTPX,ISTPY
      character*40 FNAME1,FNAME2
      character*1 YES
      print*,'Transformation of the MAP file from binary to ASCII'
   10 continue
      print*,'Name of the map file? '
      read(*,'(a)') FNAME1
      open(unit=4,file=FNAME1,err=10,form='unformatted',status='old')
   20 continue
      print*,'Name of the ASCII file? '
      read(*,'(a)') FNAME2
      open(unit=8,file=FNAME2,err=20,status='unknown')
      read(4) XMIN,XMAX,DX,YMIN,YMAX,DY
      ISTPX=nint((XMAX-XMIN)/DX)
      if(DY.eq.0.0) then
        ISTPY=1
      else
        ISTPY=nint((YMAX-YMIN)/DY)
      end if
   30 continue
      if(ISTPY.ne.1) then
        print*,
     $       'Write 1-dimensional table (each point in a separate line)'
        print*,'or'
        print*,'write 2-dimensional table (all points with same ',
     $         'x-value in one line)?'
        print*,'type 1 or 2 and press RETURN: '
        print*
        read(*,'(a)') YES
        print*,YES
      end if
      if(YES.eq.'2') then
        write(8,'(14x,64(1pe14.6:))') (YMIN+(J-1)*DY,J=1,ISTPY)
        write(*,'(14x,64(1pe14.6:))') (YMIN+(J-1)*DY,J=1,ISTPY)
        do 40 I=1,ISTPX
          read(4,err=40) (FMAP(J),J=1,ISTPY)
          write(8,'(65(1pe14.6:))') XMIN+(I-1)*DX,(FMAP(J),J=1,ISTPY)
   40   continue
      else if(YES.eq.'1') then
        do 60 I=1,ISTPX
          read(4,err=60) (FMAP(J),J=1,ISTPY)
          do 50 J=1,ISTPY
            if(XMIN+(I-1)*DX.ge.0.0) then
              write(8,'(1pe12.6,2(1pe14.6))') 
     $                              XMIN+(I-1)*DX,YMIN+(J-1)*DY,FMAP(J)
            else
              write(8,'(1pe13.6,2(1pe14.6))') 
     $                              XMIN+(I-1)*DX,YMIN+(J-1)*DY,FMAP(J)
            end if
   50     continue
   60   continue
      end if
      close(unit=8)
      close(unit=4)
      end
